Leetcode 542:01 矩阵 01

Leetcode 542:01 矩阵 01 Matrix### 题目:

给定一个由 0 和 1 组成的矩阵,找出每个元素到最近的 0 的距离。

两个相邻元素间的距离为 1 。

Given a matrix consists of 0 and 1, find the distance of the nearest 0 for each cell.

The distance between two adjacent cells is 1.

示例 1:
输入:

0 0 0
0 1 0
0 0 0

输出:

0 0 0
0 1 0
0 0 0

示例 2:
输入:

0 0 0
0 1 0
1 1 1

输出:

0 0 0
0 1 0
1 2 1

注意:

  1. 给定矩阵的元素个数不超过 10000。
  2. 给定矩阵中至少有一个元素是 0。
  3. 矩阵中的元素只在四个方向上相邻: 上、下、左、右。

Note:

  1. The number of elements of the given matrix will not exceed 10,000.
  2. There are at least one 0 in the given matrix.
  3. The cells are adjacent in only four directions: up, down, left and right.

解题思路:

? 关键字:最近、距离。那肯定是广度优先搜索。类似之前的文章 岛屿数量: https://mp.weixin.qq.com/s/BrlMzXTtZWdB7hRfCKNMoQ

将这个问题转化成图,那就是求每个节点 1 到节点 0 最短的路径是多少。从某个节点开始,上下左右向外扩展,每次扩展一圈距离累加1,如:

输入:
1 1 1
0 1 0
0 0 0

转化成图(Graph),每种颜色代表一个层级:

这就变成了求某个节点到某个节点的深度了。

所以这道题有两种思路:

  • 以节点1为根节点,求该节点到节点0之间的深度
  • 以节点0为根节点,遇到最近的节点1路径计为1,再次以记录为1的节点为根节点继续向内遍历,遇到原节点1再次累加1并得到路径2,以此类推。。。

两种方法各有优劣,

以0节点为根节点解题,要么开辟一个新的二维数组以记录路径,要么先遍历一遍将所有的节点1的值改为不可能和路径大小重复的值。

以1节点为根节点,那么就要做一些多余的重复遍历。

以0为根节点:

逻辑顺序:

以输入下列二维数组为例:

1 1 1
0 1 1
0 0 1

先把原节点值为1 的节点改为M (路径值不可能达到的值,该题中大于10000即可)

先侵染0节点附近的M节点,0节点加1之后得到1节点

再侵染1节点附近的M节点,1节点加1之后得到2节点

......

Java:

class Solution {

    public int[][] updateMatrix(int[][] matrix) {
        int row = matrix.length, column = matrix[0].length;
        int[][] neighbors = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};//邻居节点的索引偏移量
        Queue<int[]> queue = new LinkedList<>();//队列
        for (int i = 0; i < row; i++) {
            for (int j = 0; j < column; j++) {
                if (matrix[i][j] == 0) queue.offer(new int[]{i, j});
                else matrix[i][j] = Integer.MAX_VALUE;//节点值为1的节点改为一个路径不可能达到的值
            }
        }
        while (!queue.isEmpty()) {
            int[] tmp = queue.poll();
            for (int i = 0; i < 4; i++) {
                //得到邻居节点索引
                int x = tmp[0] + neighbors[i][0];
                int y = tmp[1] + neighbors[i][1];
                if (x >= 0 && x < row && y >= 0 && y < column && matrix[tmp[0]][tmp[1]] < matrix[x][y]) {
                    matrix[x][y] = matrix[tmp[0]][tmp[1]] + 1;//该节点的值得到邻居节点的路径值+1
                    queue.offer(new int[]{x, y});
                }
            }
        }
        return matrix;
    }
}

Python3:

class Solution:
    def updateMatrix(self, matrix: List[List[int]]) -> List[List[int]]:
        row, column = len(matrix), len(matrix[0])
        nerghbors = [(0, 1), (0, -1), (1, 0), (-1, 0)]
        queue = collections.deque()
        for i in range(row):
            for j in range(column):
                if matrix[i][j] == 0:
                    queue.append((i, j))
                else:
                    matrix[i][j] = 10001

        while queue:
            x, y = queue.popleft()
            for i, j in nerghbors:
                xx = i + x
                yy = j + y
                if 0 <= xx < row and 0 <= yy < column and matrix[x][y] < matrix[xx][yy]:
                    matrix[xx][yy] = matrix[x][y] + 1
                    queue.append((xx, yy))

        return matrix

以1为根节点:

Java:

class Solution {
    public int[][] updateMatrix(int[][] matrix) {
        int row = matrix.length, column = matrix[0].length;
        for (int i = 0; i < row; i++)
            for (int j = 0; j < column; j++)
                if (matrix[i][j] == 1) matrix[i][j] = bfs(matrix, i, j, row, column);
        return matrix;
    }

    private int bfs(int[][] matrix, int i, int j, int row, int column) {
        int count = 0;
        Queue<Integer> queue = new LinkedList<>();
        Set<int[]> set = new HashSet<>();
        queue.add(i * column + j);//记录索引的另一种方法
        while (!queue.isEmpty()) {
            int size = queue.size();
            count += 1;
            for (int k = 0; k < size; k++) {
                int tmp = queue.poll();
                int x = tmp / column, y = tmp % column;//得到索引坐标
                //处理上下左右四个邻居节点,遇到0节点直接返回count路径值
                if (x + 1 < row && !set.contains((x + 1) * column + y)) {
                    if (matrix[x + 1][y] != 0) queue.add((x + 1) * column + y);
                    else return count;
                }
                if (x - 1 >= 0 && !set.contains((x - 1) * column + y)) {
                    if (matrix[x - 1][y] != 0) queue.add((x - 1) * column + y);
                    else return count;
                }
                if (y + 1 < column && !set.contains(x * column + y + 1)) {
                    if (matrix[x][y + 1] != 0) queue.add(x * column + y + 1);
                    else return count;
                }
                if (y - 1 >= 0 && !set.contains(x * column + y - 1)) {
                    if (matrix[x][y - 1] != 0) queue.add(x * column + y - 1);
                    else return count;
                }
            }
        }
        return count;
    }
}

Python3:

class Solution:
    def updateMatrix(self, matrix: List[List[int]]) -> List[List[int]]:
        row, column = len(matrix), len(matrix[0])
        for i in range(row):
            for j in range(column):
                if matrix[i][j] == 1:
                    matrix[i][j] = self.bfs(i, j, matrix, row, column)

        return matrix

    def bfs(self, i: int, j: int, matrix: List[List[int]], row: int, column: int) -> int:
        queue = collections.deque()
        count = 0
        nodeset = set()
        queue.append((i, j))
        while queue:
            size = len(queue)
            count += 1
            for i in range(size):
                x, y = queue.popleft()
                if x + 1 < row and (x + 1, y) not in nodeset:
                    if matrix[x + 1][y] != 0:
                        queue.append((x + 1, y))
                    else:
                        return count
                if x - 1 >= 0 and (x - 1, y) not in nodeset:
                    if matrix[x - 1][y] != 0:
                        queue.append((x - 1, y))
                    else:
                        return count
                if y + 1 < column and (x, y + 1) not in nodeset:
                    if matrix[x][y + 1] != 0:
                        queue.append((x, y + 1))
                    else:
                        return count
                if y - 1 >= 0 and (x, y - 1) not in nodeset:
                    if matrix[x][y - 1] != 0:
                        queue.append((x, y - 1))
                    else:
                        return count
        return count

欢迎关注微.信公.众号:爱写Bug

原文地址:https://www.cnblogs.com/zhangzhe532/p/11538109.html

时间: 2024-11-03 21:10:28

Leetcode 542:01 矩阵 01的相关文章

Leetcode 542.01矩阵

01矩阵 给定一个由 0 和 1 组成的矩阵,找出每个元素到最近的 0 的距离. 两个相邻元素间的距离为 1 . 示例 1: 输入: 0 0 0 0 1 0 0 0 0 输出: 0 0 0 0 1 0 0 0 0 示例 2: 输入: 0 0 0 0 1 0 1 1 1 输出: 0 0 0 0 1 0 1 2 1 注意: 给定矩阵的元素个数不超过 10000. 给定矩阵中至少有一个元素是 0. 矩阵中的元素只在四个方向上相邻: 上.下.左.右. 思路 先把所有0入队,把1置为MAX_VALUE,然

ACDream 1213 Matrix Multiplication (01矩阵处理)

Matrix Multiplication Time Limit: 2000/1000MS (Java/Others) Memory Limit: 128000/64000KB (Java/Others) Submit Statistic Next Problem Problem Description Let us consider undirected graph G = {V; E} which has N vertices and M edges. Incidence matrix of

HNU 10111 0-1矩阵

http://acm.hnu.cn/online/?action=problem&type=show&id=10111 题意:中文 题解:在龙哥的帮助下正了二分图匹配的三观--以前的理解繁琐,或者有点儿错吧--二分图匹配从左往右匹配,找增广路.顶点数和match()不需要那么麻烦. 1 // 2 // main.cpp 3 // POJ 3041 4 // 5 // Created by zhang on 14-4-16. 6 // Copyright (c) 2014年 apple. A

统计01矩阵中全1子矩阵的个数

统计01矩阵中全1子矩阵的个数 1.51Nod 1291 题意:600*600的01矩阵,统计宽i高j的全1矩阵的个数. 题解:枚举矩阵的下边界,对于每个下边界,统计所有宽极大的矩形的答案(高度可以用差分).\(n^2\) 统计完之后,我们已知所有高度的宽极大的答案,列一下式子发现两次前缀和就是最后答案. 代码: #include<bits/stdc++.h> using namespace std; #define fi first #define se second #define mp

[EOJ Monthly 2018.10][C. 痛苦的 01 矩阵]

题目链接:C. 痛苦的 01 矩阵 题目大意:原题说的很清楚了,不需要简化_(:з」∠)_ 题解:设\(r_i\)为第\(i\)行中0的个数,\(c_j\)为第\(j\)列中0的个数,\(f_{i,j}\)代表对应格子是否为0,则有\(cost(i,j)=r_i+c_j-f_{i,j}\),\((cost(i,j))^2=r_i^2+c_j^2+f_{i,j}+2r_ic_j-2f_{i,j}(r_i+c_j)\) $$\sum_{i=1}^n \sum_{j=1}^n \left( cost(

Java 获取各时区时间,获取当前时间到格林威治时间1970年01月01日00时00分00秒的秒数

格林威治时间即UTC/GMT时间,1970年01月01日00时00分00秒(即UTC+8的北京时间1970年01月01日08时00分00秒)计算代码如下: 1 /** 2 * 获取指定时间到格林威治时间的秒数 3 * UTC:格林威治时间1970年01月01日00时00分00秒(UTC+8北京时间1970年01月01日08时00分00秒) 4 * @param time 5 * @return 6 */ 7 public static long diffSeconds(String time){

现代软件工程团队项目贝塔阶段_开发日志_2018.01.15-2018.01.19

现代软件工程团队项目贝塔阶段_开发日志_2018.01.15-2018.01.19 2018.01.15 已完成: 1.版本上线 1.1上线操作步骤 1.1.1将网站整体文件夹拷贝到keqi1 1.1.2修改microDefinition.php的数据库名和根目录名 1.1.3修改注册界面发送验证码后直接填充功能 1.1.4修改del的主id的class为hide 1.1.5重新运行根目录的111.php(消除红点,也就是消除服务器返回的多余字符) 1.2修复上线过程中遇到的bug  1.2.1

LeetCode:螺旋矩阵【54】

LeetCode:螺旋矩阵[54] 题目描述 给定一个包含 m x n 个元素的矩阵(m 行, n 列),请按照顺时针螺旋顺序,返回矩阵中的所有元素. 示例 1: 输入: [ [ 1, 2, 3 ], [ 4, 5, 6 ], [ 7, 8, 9 ] ] 输出: [1,2,3,6,9,8,7,4,5] 示例 2: 输入: [ [1, 2, 3, 4], [5, 6, 7, 8], [9,10,11,12] ] 输出: [1,2,3,4,8,12,11,10,9,5,6,7] 题目分析 这道题简直

【Leetcode 广搜、动态规划】01 矩阵(542)

题目 给定一个由 0 和 1 组成的矩阵,找出每个元素到最近的 0 的距离. 两个相邻元素间的距离为 1 . 示例 1: 输入: 0 0 0 0 1 0 0 0 0 输出: 0 0 0 0 1 0 0 0 0 示例 2: 输入: 0 0 0 0 1 0 1 1 1 输出: 0 0 0 0 1 0 1 2 1 注意: 给定矩阵的元素个数不超过 10000. 给定矩阵中至少有一个元素是 0. 矩阵中的元素只在四个方向上相邻: 上.下.左.右. 解答 也是一道搜索题.要找出每个非零数字和最近0的距离,